﻿using System;
using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Com.Syncfusion.Charts;
using Android.Graphics;
using Com.Syncfusion.Charts.Enums;
using System.IO;
using Android.Graphics.Pdf;
using Java.IO;
using Java.Util;
using System.Reflection;

namespace App1
{
    [Activity(Label = "App1", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
        SfChart sfChart;

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.Main);

            LinearLayout layout = new LinearLayout(this);
            layout.Orientation = Android.Widget.Orientation.Vertical;
            sfChart = new SfChart(this);

            DateTimeAxisExt primaryAxis = new DateTimeAxisExt()
            {
                LabelsIntersectAction = AxisLabelsIntersectAction.MultipleRows
            };
            NumericalAxis secondaryAxis = new NumericalAxis();

            sfChart.PrimaryAxis = primaryAxis;
            sfChart.SecondaryAxis = secondaryAxis;
            sfChart.SetBackgroundColor(Color.White);

            ColumnSeries series = new ColumnSeries();

            series.DataSource = GetDateTimeValue();
            series.DataMarker.ShowLabel = true;

            sfChart.Series.Add(series);

            sfChart.Behaviors.Add(new ChartZoomPanBehavior());

            layout.AddView(sfChart);
            SetContentView(layout);
        }

        public static ObservableArrayList GetDateTimeValue()
        {
            Calendar calendar = new GregorianCalendar(2015, 0, 1);
            ObservableArrayList datas = new ObservableArrayList();
            datas.Add(new ChartDataPoint(calendar.Time, 10d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 31d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 28d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 45d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 10d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 23d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 35d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 56d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 10d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 39d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 26d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 21d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(new GregorianCalendar(2015, 11, 31).Time, 35d));
            return datas;
        }

        static void addMonthDate(Calendar calendar)
        {
            calendar.Add(Java.Util.CalendarField.Month, 1);
        }
    }

    public class DateTimeAxisExt : DateTimeAxis
    {
        protected override void GenerateVisibleLabels()
        {
            base.GenerateVisibleLabels();
            ChartAxisLabel label;
            double position;

            for (int i = 1; i < VisibleLabels.Size(); i++)
            {
                label = (ChartAxisLabel)VisibleLabels.Get(i);
                position = label.Position;
                Calendar date = Calendar.Instance;
                date.TimeInMillis = (long)position;
                date.Add(Java.Util.CalendarField.Date, -1);

                label.Position = date.TimeInMillis;
                label.LabelContent = GetLabelContent(date.TimeInMillis);
            }
        }
    }
}


